VERSION 5.00
Begin VB.Form frmKeys 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Keyboard"
   ClientHeight    =   1170
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4380
   Icon            =   "IO Keyboard.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1170
   ScaleWidth      =   4380
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picBanner 
      Align           =   1  'Align Top
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   615
      Left            =   0
      MouseIcon       =   "IO Keyboard.frx":030A
      MousePointer    =   99  'Custom
      Picture         =   "IO Keyboard.frx":074C
      ScaleHeight     =   615
      ScaleWidth      =   4380
      TabIndex        =   1
      Top             =   0
      Width           =   4380
   End
   Begin VB.CommandButton cmdKeyLights 
      Caption         =   "Keyboard Lightshow"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   720
      Width           =   3495
   End
   Begin VB.Image imgKeys 
      Height          =   480
      Left            =   3840
      Picture         =   "IO Keyboard.frx":1775
      Top             =   600
      Width           =   480
   End
End
Attribute VB_Name = "frmKeys"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'==================================================================
'
' Keyboard Lighshow Dialog
' The num/caps/scroll -lock keys are turned on and off.
'
' 30 September 2001
' 09 March 2002 - Update for Windows 2000/XP
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================



'------------------------------------------------------------------
' Keyboard Object Variable

Public Keyboard As New KeyboardIO


'------------------------------------------------------------------
' Sleep for a number of seconds

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)


'------------------------------------------------------------------
' Lightshow!

Private Sub cmdKeyLights_Click()
  Dim I As Integer
  Dim J As Integer
  Dim NumState As Boolean
  Dim CapsState As Boolean
  Dim ScrollState As Boolean
  
  DoEvents
  
  NumState = Keyboard.KeyPressed(VK_NUMLOCK)
  CapsState = Keyboard.KeyPressed(VK_CAPITAL)
  ScrollState = Keyboard.KeyPressed(VK_SCROLL)
  
  ' Some windows versions lighted up the num/caps/scroll lock
  ' keys. However, this doesn't work everywhere.
  ' Instead of using the KeyPressed property,
  ' use the RaiseKeyEvent method of this.
  
  ' ADDED '
  If NumState Then Call UpdateKey(VK_NUMLOCK, True, False)
  If CapsState Then Call UpdateKey(VK_CAPITAL, True, False)
  If ScrollState Then Call UpdateKey(VK_SCROLL, True, False)
  Dim OldNumState As Boolean
  Dim OldCapsState As Boolean
  Dim OldScrollState As Boolean
  
  For I = 1 To 10
    Call Sleep(200)
    Call UpdateKey(VK_NUMLOCK, OldNumState, (I Mod 2))
    Call UpdateKey(VK_CAPITAL, OldCapsState, (I Mod 2))
    Call UpdateKey(VK_SCROLL, OldScrollState, (I Mod 2))
'    Keyboard.KeyPressed(VK_NUMLOCK) = (I Mod 2)
'    Keyboard.KeyPressed(VK_CAPITAL) = (I Mod 2)
'    Keyboard.KeyPressed(VK_SCROLL) = (I Mod 2)
  Next

  For I = 1 To 20
    Call Sleep(200)
    Call UpdateKey(VK_NUMLOCK, OldNumState, ((I + 2) Mod 3 = 0))
    Call UpdateKey(VK_CAPITAL, OldCapsState, ((I + 1) Mod 3 = 0))
    Call UpdateKey(VK_SCROLL, OldScrollState, ((I + 0) Mod 3 = 0))
'    Keyboard.KeyPressed(VK_NUMLOCK) = ((I + 2) Mod 3 = 0)
'    Keyboard.KeyPressed(VK_CAPITAL) = ((I + 1) Mod 3 = 0)
'    Keyboard.KeyPressed(VK_SCROLL) = ((I + 0) Mod 3 = 0)
  Next

  Call Sleep(200)
  Call UpdateKey(VK_NUMLOCK, OldNumState, True)
  Call UpdateKey(VK_CAPITAL, OldCapsState, True)
  Call UpdateKey(VK_SCROLL, OldScrollState, True)
'  Keyboard.KeyPressed(VK_NUMLOCK) = True
'  Keyboard.KeyPressed(VK_CAPITAL) = True
'  Keyboard.KeyPressed(VK_SCROLL) = True

  Call Sleep(200)
  Call UpdateKey(VK_NUMLOCK, OldNumState, NumState)
  Call UpdateKey(VK_CAPITAL, OldCapsState, CapsState)
  Call UpdateKey(VK_SCROLL, OldScrollState, ScrollState)
'  Keyboard.KeyPressed(VK_NUMLOCK) = NumState
'  Keyboard.KeyPressed(VK_CAPITAL) = CapsState
'  Keyboard.KeyPressed(VK_SCROLL) = ScrollState
End Sub

Private Sub UpdateKey(KeyCode As KeyboardKeys, OldState As Boolean, NewState As Boolean)
  If OldState <> NewState Then
    Call Keyboard.RaiseKeyEvent(KeyCode, False)
    Call Keyboard.RaiseKeyEvent(KeyCode, True)
    OldState = NewState
  End If
End Sub


'------------------------------------------------------------------
' Banner

Private Sub picBanner_Click()
  MsgBox "Copyright  2001 - Diederik van der Boor" & vbCrLf _
       & vbCrLf _
       & "Anyone is allowed to use this software freely, as long as" & vbCrLf _
       & "the the copright information in the source code remains intact." & vbCrLf _
       & vbCrLf _
       & "http://www.codingdomain.com"
End Sub

